// ps.cpp : Defines the entry point for the DLL application.
// Copyright (c) Dr.Spliff - 2003

#include "stdafx.h"

#include <tlhelp32.h>

#include "ps.h"

CArray<psItem,psItem> psList;

extern "C" {
	// Keep the dll loaded...
	void __stdcall LoadDll (LOADINFO *loadInfo) {
		// Do nothing
		return;
	}

	// Cleanup after being unloaded
	int __stdcall UnloadDll (int mTimeout) {
		// Dont let the dll timeout
		if (mTimeout == 1) {
			return(0);
		} else {
			psList.RemoveAll();
		}

		return(1);
	}

	// Return the number of processes we have
	int __stdcall getProcNum (HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, BOOL nopause) {
		itoa(psList.GetSize(), data, 10);
		return(3);
	}

	// Return info for a specific process
	int __stdcall getProcInfo (HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, BOOL nopause) {
		psItem tmpItem;
		int tmpIndex;

		tmpIndex = atoi(data);
		if (tmpIndex == 0) {
			strcpy(data, "ERROR");
			return(3);
		}

		// Some error checking... 
		if (tmpIndex > psList.GetSize()) {
			strcpy(data, "ERROR");
			return(3);
		}

		tmpItem = psList.GetAt(tmpIndex);
		if (tmpItem.id < 4) {
			strcpy(data, "ERROR");
			return(3);
		} else {
			sprintf(data, "%d|%s", tmpItem.id, tmpItem.exe);
			return(3);
		}
	}

	// Kill a process given the pid
	int __stdcall killProc (HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, BOOL nopause) {
		HANDLE kProc;
		int tmpPid;

		tmpPid = atoi(data);
		if (!tmpPid || tmpPid < 4) {
			strcpy(data, "ERROR No such process");
			return(3);
		}

		// Terminate the process
		kProc = OpenProcess(PROCESS_TERMINATE, FALSE, tmpPid);
		TerminateProcess(kProc, 0x01);
		return(1);
	}

	// Clear the internal process list
	int __stdcall clearList (HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, BOOL nopause) {
		psList.RemoveAll();
		return(1);
	}

	// Update the internal process list
	int __stdcall updateList (HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, BOOL nopause) {
		HANDLE hSnapshot = CreateToolhelp32Snapshot(TH32CS_SNAPPROCESS, 0);

		// Cannot get the process snapshot... EEP!
		if (hSnapshot == INVALID_HANDLE_VALUE) {
			strcpy(data, "ERROR");
			return(3);
		}

		psList.RemoveAll();

		PROCESSENTRY32 pe;
		MODULEENTRY32 me;
	
		pe.dwSize = sizeof(PROCESSENTRY32);
		me.dwSize = sizeof(MODULEENTRY32);

		BOOL retval = Process32First(hSnapshot, &pe);
		BOOL bGotModule = FALSE;
		psItem tmpItem;

		// Loop through them all
		while(retval) {
			if (pe.th32ProcessID > 4) {
				
				// Get a snapshot of the process' modules (PROCESSENTRY32 doesn't contain the full path...)
				HANDLE hModuleSnap = CreateToolhelp32Snapshot(TH32CS_SNAPMODULE, pe.th32ProcessID);
				bGotModule = Module32First(hModuleSnap, &me);

				// Check we got the module 
				if (bGotModule) {
					strcpy(tmpItem.exe, me.szExePath);
					tmpItem.id = pe.th32ProcessID;
					psList.Add(tmpItem);
				}

				CloseHandle(hModuleSnap);
			}

			pe.dwSize = sizeof(PROCESSENTRY32);
			retval = Process32Next(hSnapshot, &pe);
		}

		CloseHandle(hSnapshot);

		return(1);
	}


	// Return the version/copyright string
	int __stdcall version (HWND mWnd, HWND aWnd, char *data, char *parms, BOOL show, BOOL nopause) {
		strcpy(data, "Process Control v0.5 - Copyright (C) Dr.Spliff 2003");
		return(3);
	}
}

